#include <stdio.h>
#include <stdlib.h>
#include <sj3lib.h>

int sj3_open(char *, char *);
int sj3_close(void);
int sj3_getkan_euc(unsigned char *, struct bunsetu[], unsigned char *, int);
int sj3_douoncnt_euc(unsigned char *);
int sj3_getdouon_euc(unsigned char *, struct douon[]);

static char *
strndup(char *p, int n)
{
    int k;
    char *q;

    if ((q = (char *)malloc(n + 1)) == NULL)
	return (NULL);
    for (k = 0; k < n; ++k)
	q[k] = p[k];
    q[k] = 0;
    return (q);
}

int
main(int ac, char **av)
{
#if 0
    unsigned char *euc = "ʤȤĤ夦ˤФ󤷤ޤ";
#else
    unsigned char *euc = "ɤ󤤤Τ";
#endif
    unsigned char buf[1024];    
    struct bunsetu bun[1024];
    const int len = 1024;
    int n, status;

    /* */
    if ((status = sj3_open("localhost", "syl")) != 0) {
	if (status & SJ3_SERVER_DEAD)
	    fprintf(stderr, "%s: ³˥Ф󤷤ޤ\n",
		    av[0]);
	if (status & SJ3_CONNECT_ERROR)
	    fprintf(stderr, "%s: Фʤ뤤³Ǥޤ\n",
		    av[0]);
	if (status & SJ3_ALREADY_CONNECTED)
	    fprintf(stderr, "%s: Warning: Ǥ˥Ф³ѤߤǤ\n",
		    av[0]);
	if (status & SJ3_CANNOT_OPEN_MDICT)
	    fprintf(stderr, "%s: Warning: ᥤ󼭽򥪡ץǤޤ\n",
		    av[0]);
	if (status & SJ3_CANNOT_OPEN_UDICT)
	    fprintf(stderr, "%s: Warning: 桼򥪡ץǤޤ\n",
		    av[0]);
	if (status & SJ3_CANNOT_OPEN_UDICT)
	    fprintf(stderr, "%s: Warning: ؽե򥪡ץǤޤ\n",
		    av[0]);
	if (status & SJ3_CANNOT_MAKE_UDIR)
	    fprintf(stderr, "%s: Warning: ĿͥեΤΥǥ쥯ȥ"
		    "Ǥޤ\n", av[0]);
	if (status & SJ3_CANNOT_MAKE_UDICT)
	    fprintf(stderr, "%s: Warning: 桼Ǥޤ\n",
		    av[0]);
	if (status & SJ3_CANNOT_MAKE_STUDY)
	    fprintf(stderr, "%s: Warning: ؽեǤޤ\n",
		    av[0]);
	if (status & (SJ3_SERVER_DEAD | SJ3_CONNECT_ERROR))
	    exit(1);
    }

    /* */
    printf("Ѵʸ `%s'\n", euc);
    status = sj3_getkan_euc(euc, bun, buf, len);
    if (status == -1) {
	fprintf(stderr, "%s: Ф³Ƥʤ뤤ϥФ"
		"Ƥ뤿ᡢѴǤޤǤ\n", av[0]);
    }
    else if (status == 0) {
	fprintf(stderr, "%s: Ѵʸ󤬶Ǥ롢뤤Ĺ"
		"Ƥ뤿ᡢѴǤޤǤ\n", av[0]);
    }
    else {
	printf("ʸ: %d\n"
	       "Ѵ: `%s'\n",
	       status, buf);
	for (n = 0; n < status; ++n) {
	    int k, m;
	    char *p, *q;
	    struct douon d[10];

	    printf("ʸ[%d]: ", n);
	    p = strndup(bun[n].srcstr, bun[n].srclen);
	    q = strndup(bun[n].deststr, bun[n].destlen);
	    printf("%s:%s\n", p, q);
	    m = sj3_getdouon_euc(p, d);
	    printf("ʸ[%d]Ʊ۵: %d\n", n, m);
	    printf("ʸ[%d]Ʊ۵:", n);
	    for (k = 0; k < m; ++k) {
		printf(" %s", d[k].ddata);
	    }
	    printf("\n");
	    free(p);
	    free(q);
	}
    }

    /* */
    if ((status = sj3_close()) != 0) {
	fprintf(stderr, "%s: Warning: sj3ФȤ³ڤΥȤˡ"
		"ʤˤ顼ޤ\n", av[0]);
    }
    exit(0);
    return (0);
}
